"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ZirusCacheInterceptor = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const utils_1 = require("../utils");
const rxjs_1 = require("rxjs");
const cache_constants_1 = require("../cache.constants");
let ZirusCacheInterceptor = class ZirusCacheInterceptor {
    constructor(cacheManager, reflector) {
        this.cacheManager = cacheManager;
        this.reflector = reflector;
    }
    async intercept(context, next) {
        var _a;
        const request = context.switchToHttp().getRequest();
        const condition = await this.reflector.get(cache_constants_1.CACHE_COND_METADATA, context.getHandler());
        if ((0, utils_1.isFunction)(condition) && !condition(context))
            return next.handle();
        if (request.method !== 'GET')
            return next.handle();
        const cacheKey = this.reflector.get(cache_constants_1.CACHE_KEY_METADATA, context.getHandler()) ||
            await ((_a = this.reflector.get(cache_constants_1.CACHE_TRACKER_METADATA, context.getHandler())) === null || _a === void 0 ? void 0 : _a(context)) ||
            request.url;
        const value = await this.cacheManager.get(cacheKey);
        const ttlValueOrFactory = this.reflector.get(cache_constants_1.CACHE_TTL_METADATA, context.getHandler());
        const ttl = (0, utils_1.isFunction)(ttlValueOrFactory)
            ? await ttlValueOrFactory(context)
            : ttlValueOrFactory || 0;
        if (value !== undefined) {
            return (0, rxjs_1.of)(value);
        }
        else {
            return next.handle().pipe((0, rxjs_1.tap)(async (response) => await this.cacheManager.set(cacheKey, await response, {
                ttl: ttl
            })));
        }
    }
};
ZirusCacheInterceptor = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(cache_constants_1.CACHE_MANAGER)),
    __param(1, (0, common_1.Inject)(core_1.Reflector.name)),
    __metadata("design:paramtypes", [Object, core_1.Reflector])
], ZirusCacheInterceptor);
exports.ZirusCacheInterceptor = ZirusCacheInterceptor;
//# sourceMappingURL=cache.interceptor.js.map